"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const loader_utils_1 = __importDefault(require("loader-utils"));
function default_1(source) {
    const options = loader_utils_1.default.getOptions(this);
    const allBlocks = options.blocksList;
    const blocksData = [];
    const allRequires = allBlocks.map((block, index) => {
        blocksData.push(`{
      block: block${index},
      theme: '${block.theme}',
    }`);
        if (block.path) {
            return `
        var block${index} = require(process.env.CONTENT_PATH + "/${block.path}/index.vue");\n
        block${index} = block${index}.default || block${index};\n
        window.__components.push(block${index});\n
        blocksList['${block.id}']=block${index};`;
        }
        return `
      var block${index} = require(EWIZARDJS.SYSTEM_SETTINGS.absolutePath.blocks + "/${block.id}/index.vue");\n
      block${index} = block${index}.default || block${index};\n
      window.__components.push(block${index});\n
      blocksList['${block.id}']=block${index};`;
    }).join('\n');
    const allBlocksInjected = source.replace(/(?<=marker-components-start\/)[\s\S]*(?=\/marker-components-end)/, `\n const blocksList = {};\n${allRequires}\n`);
    const result = allBlocksInjected.replace(/(?<=marker-blocks-start\/)[\s\S]*(?=\/marker-blocks-end)/, '\n const block = blocksList[id]; \n');
    return result;
}
exports.default = default_1;
//# sourceMappingURL=entry-editor-loader.js.map