"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.filename = void 0;
const cleanDestinationFolder_1 = require("../plugins/cleanDestinationFolder");
const upath_1 = require("upath");
const webpack_merge_1 = __importDefault(require("webpack-merge"));
exports.filename = 'build/dev/templates.js';
exports.default = (presentationPath, config) => {
    const templatesConfig = getTemplatesConfig(presentationPath);
    return webpack_merge_1.default({
        customizeArray(item1, item2, key) {
            if (key === 'plugins') {
                const defaultPlugins = item1;
                const templatesPlugins = item2;
                return removeCleanWebpackPlugin(defaultPlugins).concat(templatesPlugins);
            }
        },
    })(config, templatesConfig);
};
function getTemplatesConfig(presentationPath) {
    return {
        entry: require.resolve('../../assets/entry-templates.js'),
        mode: 'production',
        devtool: false,
        output: {
            filename: exports.filename,
            library: 'Templates',
            libraryTarget: 'window',
        },
        performance: {
            hints: false,
        },
        plugins: [
            cleanDestinationFolder_1.cleanDestinationFolder([upath_1.join(presentationPath, exports.filename)]),
        ],
    };
}
function removeCleanWebpackPlugin(plugins = []) {
    return plugins.filter(plugin => plugin.constructor && plugin.constructor.name !== 'CleanWebpackPlugin');
}
//# sourceMappingURL=webpack.config.js.map